TITLE 'Test Program Five for the ConsoleIO board'

Prop$Key$Status	EQU	014H		;Base address of the ConsoleIO Prop0 
Prop$Key$Data	EQU	015H		

;	PORTS  FOR FOR S-100 SD Systems Video Board

S100$CIN	EQU	1H		;IN Data SD Systems Video Board
S100$COUT	EQU	1H		;OUT Data SD Systems Video Board
S100$CSTAT	EQU	0H		;Status Port SD Systems Video Board

	ORG	100H 

	LXI	SP,STACK		;Setup a stack for good practice
	MVI	C,'>'
	CALL	ZCO
	
BEGIN:	IN	Prop$Key$Status		;Read Console IN status bit
	;in	S100$CSTAT 
	ANI	2			;Is there a keyboard character
	JZ	BEGIN			;NZ, Nothing at keyboard
	
	IN	Prop$Key$Data		;Get the the keyboard data from the Propeller board
	;in	S100$CIN
	ani	7fh
	MOV	C,A			;Store in [C]
	CPI	'1'
	JZ	SENDMSG
	CALL	CONOUT			;Also put it on the S-100 video board.
;	mvi	a,5
;zzz	dcr	a
;	jnz	ZZZ
	JMP	BEGIN
	
CONOUT:	IN	Prop$Key$Status		;Read Console OUT status bit 
	ANI	4			;Is board busy		
	JZ	CONOUT
	MOV	A,C
	OUT	Prop$Key$Data		;Send the data to the Propeller video
	RET
	
SENDMSG:
	LXI	H,MSG
MORE:	MOV	A,M
	INX	H
	ORA	A
	JZ	BEGIN
	MOV	C,A
	CALL	CONOUT
	JMP	MORE
	
MSG:	DB	'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',0DH,0AH,0AH
	DB	'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',0DH,0AH,0AH
	DB	'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',0DH,0AH,0AH,0
	
	
		
LBYTE:	PUSH	PSW	
	PUSH	B
	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	ZCONV
	POP	PSW
	CALL	ZCONV
;	CALL	CRLF
	POP	B
	POP	PSW
	RET
;
ZCONV:	ANI	0FH	;HEX to ASCII and print it
	ADI	90H
	DAA
	ACI	40H
	DAA
	MOV	C,A
	CALL	ZCO
	RET


ZCO:	IN	(S100$CSTAT)		;console output (arrive with character in C)
	ANI	04H			;Note character is in C and A on return.
	JZ	ZCO
	MOV	A,C
	OUT	(S100$COUT)
	RET

CRLF	MVI	C,0DH
	CALL	ZCO
	MVI	C,0AH
	CALL	ZCO
	RET
	
	
	DS	100H
STACK	DW	0H

